<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\equity;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\equity\UserEquityLists;
use app\adminapi\logic\equity\UserEquityLogic;
use app\adminapi\logic\export\ExportLogic;
use app\adminapi\validate\equity\UserEquityValidate;
use app\common\service\ExcelExportService;


/**
 * UserEquity控制器
 * Class UserEquityController
 * @package app\adminapi\controller
 */
class UserEquityController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/12/19 11:43
     */
    public function lists()
    {
        return $this->dataLists(new UserEquityLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/12/19 11:43
     */
    public function add()
    {
        $params = (new UserEquityValidate())->post()->goCheck('add');
        $result = UserEquityLogic::add($params);
        if (true === $result) {
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(UserEquityLogic::getError());
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/12/19 11:43
     */
    public function edit()
    {
        $params = (new UserEquityValidate())->post()->goCheck('edit');
        $result = UserEquityLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(UserEquityLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/12/19 11:43
     */
    public function delete()
    {
        $params = (new UserEquityValidate())->post()->goCheck('delete');
        UserEquityLogic::delete($params);
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/12/19 11:43
     */
    public function detail()
    {
        $params = (new UserEquityValidate())->goCheck('detail');
        $result = UserEquityLogic::detail($params);
        return $this->data($result);
    }

    public function serviceWorkDetail()
    {
        $params = $this->request->param();
        $result = UserEquityLogic::serviceWorkDetail($params);
        return $this->data($result);
    }
    public function download()
    {
        $params = $this->request->post();
        $filename = "权益卡列表";
        $result = ExportLogic::add([
            'download_type' => 3,
            'params' => $params,
            'name' => $filename,
            'admin_id' => $this->adminId,
        ]);
        if (false === $result) {
            return $this->fail(ExportLogic::getError());
        }
        // 暂时 - 立即生成导出文件
        (new ExcelExportService)->download($result);
        return $this->success('添加成功-'.$result, [], 1, 1);
    }
}